#include "Pintor.h"

#define     CIMA    1
#define    BAIXO    2
#define  DIREITA    3
#define ESQUERDA    4

#define GALINHA1    0
#define GALINHA2    1
#define MINHOCA     10
#define RIO         2
#define JACARE      4
#define TARTARUGA   5
#define BARCO       6
#define TRONCO      7
#define CARRO       8

#define ANDANDO     0
#define PARADO      2
#define MOVENDO     3


#define VEL         3
#define VIDAS       6


Pintor::Pintor() {
	this->buffer = create_bitmap(800, 1080);
	this->tela = create_bitmap(800, 1080);
	this->carro = new SpriteCarro("carro.bmp", 75, 70, 450, 140);
	this->galinha1 = new SpriteGalinha("galinha.bmp", 60, 60, 360, 240);
	this->galinha2 = new SpriteGalinha("galinha2.bmp", 60, 60, 360, 240);
	this->cenarioPausa = load_bitmap("desenho.bmp", NULL);
	this->cenario1 = load_bitmap("estagio1.bmp", NULL);
	this->cenario2 = load_bitmap("estagio2.bmp", NULL);
	this->tronco = load_bitmap("tronco.bmp", NULL);
	this->minhoca = load_bitmap("minhoca.bmp", NULL);

	this->iGalinha1 = 0;
	this->jGalinha1 = 0;
	this->iGalinha2 = 0;
	this->jGalinha2 = 0;

	this->iCarro = 0;
	this->jCarro = 0;
}

void Pintor::atualizaDados(TLogica *atual) {

	int size;

	if (!atual->pausado) {

		TObjetoPalco *noPalco;
		if (atual->estagioAtual == 1) {
			blit(cenario1, tela, 0, 0, 0, 0, 800, 1080);
			noPalco = atual->aux1;
			size = 19;
		} else {
			blit(cenario2, tela, 0, 0, 0, 0, 800, 1080);
			noPalco = atual->aux2;
			size = 24;
		}

		int i;

		for (i = 2; i < size; i++) {

			if (noPalco[i].tipo == TRONCO && noPalco[i].visivel) {
				draw_sprite(this->tela, this->tronco, noPalco[i].x,
						noPalco[i].y);
			}

			else if (noPalco[i].tipo == MINHOCA && noPalco[i].visivel) {
				draw_sprite(this->tela, this->minhoca, noPalco[i].x,
						noPalco[i].y);
			}

			else if (noPalco[i].tipo == CARRO && noPalco[i].visivel) {

				if (noPalco[i].direcao == DIREITA) {
					draw_sprite(this->tela, this->carro->getAndando(),
							noPalco[i].x, noPalco[i].y);
				} else if (noPalco[i].direcao == ESQUERDA) {
					draw_sprite_h_flip(this->tela, this->carro->getAndando(),
							noPalco[i].x, noPalco[i].y);
				}

			}
		}

		if (noPalco[1].visivel) {

			if (noPalco[1].direcao == CIMA) {
				//  this->iGalinha1 = 0;
				draw_sprite(this->tela, galinha2->getAndandoCima(),
						noPalco[1].x, noPalco[1].y);
			} else if (noPalco[1].direcao == BAIXO) {
				// this->iGalinha1 = 1;
				draw_sprite(this->tela, galinha2->getAndandoBaixo(),
						noPalco[1].x, noPalco[1].y);
			} else if (noPalco[1].direcao == ESQUERDA) {
				// this->iGalinha1 = 2;
				draw_sprite(this->tela, galinha2->getAndandoEsquerda(),
						noPalco[1].x, noPalco[1].y);
			} else if (noPalco[1].direcao == DIREITA) {
				// this->iGalinha1 = 3;
				draw_sprite(this->tela, galinha2->getAndandoDireita(),
						noPalco[1].x, noPalco[1].y);
			}

			if (noPalco[1].estado == PARADO) {
				// this->jGalinha1 = 2;
				if (noPalco[1].direcao == CIMA) {
					draw_sprite(this->tela, galinha2->getParadaCima(),
							noPalco[1].x, noPalco[1].y);
				} else if (noPalco[1].direcao == BAIXO) {
					draw_sprite(this->tela, galinha2->getParadaBaixo(),
							noPalco[1].x, noPalco[1].y);
				} else if (noPalco[1].direcao == ESQUERDA) {
					draw_sprite(this->tela, galinha2->getParadoEsquerda(),
							noPalco[1].x, noPalco[1].y);
				} else if (noPalco[1].direcao == DIREITA) {
					draw_sprite(this->tela, galinha2->getParadoDireita(),
							noPalco[1].x, noPalco[1].y);
				}
			}
			//  else{
			// this->jGalinha1++;
			/*  if (this->jGalinha1 > 6 ){
			 this->jGalinha1 = 0;
			 }*/
			//     }
			//  draw_sprite(this->tela, this->galinha2->corta_sprite(this->iGalinha1, this->jGalinha1),  noPalco[1].x,  noPalco[1].y);
		}

		if (noPalco[0].direcao == CIMA) {
			//   this->iGalinha2 = 0;
			draw_sprite(this->tela, galinha1->getAndandoCima(), noPalco[0].x,
					noPalco[0].y);
		} else if (noPalco[0].direcao == BAIXO) {
			//   this->iGalinha2 = 1;
			draw_sprite(this->tela, galinha1->getAndandoBaixo(), noPalco[0].x,
					noPalco[0].y);
		} else if (noPalco[0].direcao == ESQUERDA) {
			//    this->iGalinha2 = 2;
			draw_sprite(this->tela, galinha1->getAndandoEsquerda(),
					noPalco[0].x, noPalco[0].y);
		} else if (noPalco[0].direcao == DIREITA) {

			draw_sprite(this->tela, galinha1->getAndandoDireita(),
					noPalco[0].x, noPalco[0].y);
		}

		if (noPalco[0].estado == PARADO) {

			if (noPalco[0].direcao == BAIXO) {
				draw_sprite(this->tela, galinha1->getParadaBaixo(),
						noPalco[0].x, noPalco[0].y);
			} else if (noPalco[0].direcao == CIMA) {
				draw_sprite(this->tela, galinha1->getParadaCima(),
						noPalco[0].x, noPalco[0].y);
			} else if (noPalco[0].direcao == ESQUERDA) {
				draw_sprite(this->tela, galinha1->getParadoEsquerda(),
						noPalco[0].x, noPalco[0].y);
			} else if (noPalco[0].direcao == DIREITA) {
				draw_sprite(this->tela, galinha1->getParadoDireita(),
						noPalco[0].x, noPalco[0].y);
			}

		}

		if (atual->numeroDeJogadores == 1) {
			if (noPalco[0].y > 300 && noPalco[0].y < 780) {
				int deltaY = 780 - noPalco[0].y;
				atual->estagio.y = 480 - deltaY;
			}
		} else {

			int y1 = noPalco[0].y;
			int y2 = noPalco[1].y;
			int y3 = noPalco[size - 1].y;

			if (y1 <= 540 && y2 <= 540 && y3 <= 600) {
				atual->estagio.y = 0;
			}

		}
		draw_sprite(this->buffer, this->tela, 0, 0);

	}

}
