
#include "Teclado.h"

Teclado:: Teclado(int _interface){
    this->interface = _interface;
}

int Teclado:: verificaEntradas(){

    if (this->interface == INTERFACE_PL2)
    {
        return this->verificaPL2();
    }

    else if(this->interface == INTERFACE_MENU)
    {
        return this->verificaMenu();
    }

    else
    {
        return this-> verificaPL1();
    }
}

////////////////////////////////////////////////////////////////////////////////
//PLAYER 1
////////////////////////////////////////////////////////////////////////////////
int Teclado:: verificaPL1(){

    int tecla=SEM_TECLA;

    //PLAYER 1

    if (key[KEY_S])
    {
        tecla = PL1_BAIXO;
    }

    else if (key[KEY_W])
    {
        tecla = PL1_CIMA;
    }

    else if (key[KEY_A])
    {
        tecla = PL1_ESQUERDA;
    }

    else if (key[KEY_D])
    {
        tecla = PL1_DIREITA;
    }

    else if (key[KEY_SPACE])
    {
        tecla = PL1_PAUSE;
    }

    else if (key[KEY_Y])
    {
        tecla = TECLA_SECRETA;
    }

    else if (key[KEY_ESC])
    {
        tecla = SAIR_JOGO;
    }

    return tecla;

}


////////////////////////////////////////////////////////////////////////////////
//PLAYER 2
////////////////////////////////////////////////////////////////////////////////
int Teclado:: verificaPL2(){

    int tecla=SEM_TECLA;

    //PLAYER 2

    if (key[KEY_DOWN])
    {
        tecla = PL2_BAIXO;
    }

    else if (key[KEY_UP])
    {
        tecla = PL2_CIMA;
    }

    else if (key[KEY_LEFT])
    {
        tecla = PL2_ESQUERDA;
    }

    else if (key[KEY_RIGHT])
    {
        tecla = PL2_DIREITA;
    }

    else if (key[KEY_SPACE])
    {
        tecla = PL2_PAUSE;
    }

    else if (key[KEY_Y])
    {
        tecla = TECLA_SECRETA;
    }

    else if (key[KEY_ESC])
    {
        tecla = SAIR_JOGO;
    }

    return tecla;

}

////////////////////////////////////////////////////////////////////////////////
//MENU
////////////////////////////////////////////////////////////////////////////////
int Teclado:: verificaMenu(){

    int tecla=SEM_TECLA;

    //MENU

    if (key[KEY_DOWN])
    {
        tecla = MENU_BAIXO;
    }

    else if (key[KEY_UP])
    {
        tecla = MENU_CIMA;
    }

    else if (key[KEY_SPACE])
    {
        tecla = MENU_SELECT;
    }

    else if (key[KEY_LSHIFT] || key[KEY_RSHIFT])
    {
        tecla = MENU_AJUDA;
    }



    return tecla;

}
