#include "ObjetoPalco.h"

ObjetoPalco :: ObjetoPalco(Estagio* _level, int _tipo, int _x, int _y, int _l, int _h, int _vel, bool _visivel){

    this->tipo = _tipo;
    this->x =       _x;
    this->y =       _y;
    this->h =       _h;
    this->l =       _l;
    this->pontos =   0;
    this->velocidade = _vel;
    this->visivel = _visivel;
    this->level = _level;


    if (_tipo == GALINHA1 || _tipo == GALINHA2){
        this->estado = PARADO;
        this->direcao = CIMA;
        this->vidas = VIDAS;
    }
    else{
        this->vidas = 0;
        this->estado = 2;
    }
}



void ObjetoPalco:: toStruct(TObjetoPalco * retorno){
	retorno->x = this->x;
	retorno->y = this->y;
	retorno->h = this->h;
	retorno->l = this->l;
	retorno->direcao = this->direcao;
	retorno->estado = this->estado;
	retorno->pontos = this->pontos;
	retorno->velocidade = this->velocidade;
	retorno->tipo = this->tipo;
	retorno->vidas = this->vidas;
	retorno->visivel = this->visivel;

	TEstagio lev;
	this->level->toStruct(&lev);
	retorno->level = lev;
}


//MOVIMENTACAO NORMAL
void ObjetoPalco :: andarParaDireita (){

    this->direcao = DIREITA;
    this->estado  = ANDANDO;

    this->x = this->x + VEL*this->velocidade;

    if (this->x > this->level->l  - l){

        this->x = this->level->l  - l;
    }
}

void ObjetoPalco :: andarParaEsquerda (){

    this->direcao= ESQUERDA;
    this->estado  = ANDANDO;

    this->x = this->x - VEL*this->velocidade;

    if (this->x<0){

        this->x = 0;
    }

}

void ObjetoPalco :: andarParaBaixo (){

    this->direcao= BAIXO;
    this->estado  = ANDANDO;

    y = y + VEL*this->velocidade;

    if (this->y > this->level->h - h){

        this->y = this->level->h - h;
    }

}

void ObjetoPalco :: andarParaCima (){

    this->direcao= CIMA;
    this->estado  = ANDANDO;

    this->y = this->y - VEL*this->velocidade;

    if (this->y<0){

        this->y = 0;
    }
}


void ObjetoPalco:: parou(){
    this->estado = PARADO;
}


//MOVIMENTACAO SOBRE ALGUM OBJETO(EX: TRONCO)
void ObjetoPalco :: andarDirSobreObj (int velDoObjeto){

    this->x = this->x + VEL * velDoObjeto;

    if (this->x > this->level->l - l){

        this->x = this->level->l - l;
    }

}

void ObjetoPalco :: andarEsqSobreObj (int velDoObjeto){

    this->x = this->x - VEL * velDoObjeto;

    if (this->x<0){

        this->x = 0;

    }
}

Retorno ObjetoPalco::colidir(ObjetoPalco ** array, int size){

    int i;
    Retorno retorno;
    retorno.ret = 0;
    retorno.minhoca = false;
    Retorno r;
    r.ret = 0;
    r.minhoca = false;
    for (i=0; i <size; i++){
        if (colidiu(array[i])){

           if ( (this->tipo == GALINHA1 || this->tipo == GALINHA2 ) && this->visivel == true){
                r = colisao(array[i]);
                retorno.ret += r.ret;
                retorno.minhoca = r.minhoca;
           }

        }
    }
return retorno;
}

Retorno ObjetoPalco::colisao(ObjetoPalco* objetoColidido){

    Retorno retorno;
    retorno.ret = 0;
    retorno.minhoca = false;

    if(objetoColidido != NULL){
        if (objetoColidido->visivel == true){
           if (objetoColidido == this) return retorno;
           if(objetoColidido->tipo == MINHOCA){

                this->pontuar();
                retorno.minhoca = true;

            }else if(objetoColidido->tipo == TRONCO){

                if (objetoColidido->direcao == ESQUERDA)this->andarEsqSobreObj(objetoColidido->velocidade);
                else this->andarDirSobreObj(objetoColidido->velocidade);
                retorno.ret = 1;

            }else if(objetoColidido->tipo == RIO){
                retorno.ret = -1;

            }
            else if( objetoColidido->tipo == CARRO){
                retorno.ret = -1;

            }
        }

    }

    return retorno;
}

void ObjetoPalco :: morreu(){
        this->vidas--;
        if (this->tipo == GALINHA1){
            this->x = this->level->xMorreu1;
        }
        else{
            this->x = level->xMorreu2;
        }
        this->estado = PARADO;
        this->direcao = CIMA;
        this->y = this->level->yMorreu;
}

bool ObjetoPalco::colidiu(ObjetoPalco* colidido){
    int x = this->x;
    int y = this->y;
    int h = this->h;
    int l = this->l;

    int x_c = colidido->x;
    int y_c = colidido->y;
    int h_c = colidido->h;
    int l_c = colidido->l;

    if ( (x<x_c + l_c) && (x+l > x_c)){
        if ( (y< y_c + h_c) && (y+h> y_c) ){
            return true;
        }
    }
    return false;
}

void ObjetoPalco:: pontuar(){

}

void ObjetoPalco:: andar(){

    if (this->tipo == TRONCO || this->tipo == CARRO){

        if (this->direcao == DIREITA){
            this->x = this->x + VEL*this->velocidade;
            if (this->x >= 800){
                this->x = 0 - this->l;
            }
        }
        else {
            this->x = this->x - VEL*this->velocidade;
            if (this->x <= 0 - this->l){
                this->x = 800;
            }
        }
    }
}
