/*
 *  MICO --- an Open Source CORBA implementation
 *  Copyright (c) 1997-2006 by The Mico Team
 *
 *  This file was automatically generated. DO NOT EDIT!
 */

#include <CORBA.h>
#include <mico/throw.h>

#ifndef __SERVIDOR_H__
#define __SERVIDOR_H__




class Servidor;
typedef Servidor *Servidor_ptr;
typedef Servidor_ptr ServidorRef;
typedef ObjVar< Servidor > Servidor_var;
typedef ObjOut< Servidor > Servidor_out;



struct est;
typedef TFixVar< est > est_var;
typedef est& est_out;


struct est {
  #ifdef HAVE_TYPEDEF_OVERLOAD
  typedef est_var _var_type;
  #endif
  #ifdef HAVE_EXPLICIT_STRUCT_OPS
  est();
  ~est();
  est( const est& s );
  est& operator=( const est& s );
  #endif //HAVE_EXPLICIT_STRUCT_OPS

  CORBA::Long x;
  CORBA::Long y;
  CORBA::Long h;
  CORBA::Long l;
  CORBA::Long tipo;
  CORBA::Long xInicio1;
  CORBA::Long yInicio;
  CORBA::Long xInicio2;
  CORBA::Long xMorreu1;
  CORBA::Long xMorreu2;
  CORBA::Long yMorreu;
};

typedef est TEstagio;
typedef est_var TEstagio_var;
typedef est_out TEstagio_out;

struct obj;
typedef TFixVar< obj > obj_var;
typedef obj& obj_out;


struct obj {
  #ifdef HAVE_TYPEDEF_OVERLOAD
  typedef obj_var _var_type;
  #endif
  #ifdef HAVE_EXPLICIT_STRUCT_OPS
  obj();
  ~obj();
  obj( const obj& s );
  obj& operator=( const obj& s );
  #endif //HAVE_EXPLICIT_STRUCT_OPS

  CORBA::Long x;
  CORBA::Long y;
  CORBA::Long h;
  CORBA::Long l;
  CORBA::Long direcao;
  CORBA::Long estado;
  CORBA::Long pontos;
  CORBA::Long velocidade;
  CORBA::Long tipo;
  TEstagio level;
  CORBA::Long vidas;
  CORBA::Boolean visivel;
};

typedef obj TObjetoPalco;
typedef obj_var TObjetoPalco_var;
typedef obj_out TObjetoPalco_out;

struct log;
typedef TFixVar< log > log_var;
typedef log& log_out;


struct log {
  #ifdef HAVE_TYPEDEF_OVERLOAD
  typedef log_var _var_type;
  #endif
  #ifdef HAVE_EXPLICIT_STRUCT_OPS
  log();
  ~log();
  log( const log& s );
  log& operator=( const log& s );
  #endif //HAVE_EXPLICIT_STRUCT_OPS

  TEstagio estagio;
  CORBA::Long numeroDeJogadores;
  CORBA::Long estagioAtual;
  CORBA::Long minhocasComidas;
  CORBA::Boolean pausado;
  TObjetoPalco aux1[ 20 ];
  TObjetoPalco aux2[ 30 ];
};

typedef log TLogica;
typedef log_var TLogica_var;
typedef log_out TLogica_out;


/*
 * Base class and common definitions for interface Servidor
 */

class Servidor : 
  virtual public CORBA::Object
{
  public:
    virtual ~Servidor();

    #ifdef HAVE_TYPEDEF_OVERLOAD
    typedef Servidor_ptr _ptr_type;
    typedef Servidor_var _var_type;
    #endif

    static Servidor_ptr _narrow( CORBA::Object_ptr obj );
    static Servidor_ptr _narrow( CORBA::AbstractBase_ptr obj );
    static Servidor_ptr _duplicate( Servidor_ptr _obj )
    {
      CORBA::Object::_duplicate (_obj);
      return _obj;
    }

    static Servidor_ptr _nil()
    {
      return 0;
    }

    virtual void *_narrow_helper( const char *repoid );

    virtual CORBA::Long processaJogo( CORBA::Long digitadoPlayer1, CORBA::Long digitadoPlayer2 ) = 0;
    virtual ::TLogica getTLogica() = 0;

  protected:
    Servidor() {};
  private:
    Servidor( const Servidor& );
    void operator=( const Servidor& );
};

// Stub for interface Servidor
class Servidor_stub:
  virtual public Servidor
{
  public:
    virtual ~Servidor_stub();
    CORBA::Long processaJogo( CORBA::Long digitadoPlayer1, CORBA::Long digitadoPlayer2 );
    ::TLogica getTLogica();

  private:
    void operator=( const Servidor_stub& );
};

#ifndef MICO_CONF_NO_POA

class Servidor_stub_clp :
  virtual public Servidor_stub,
  virtual public PortableServer::StubBase
{
  public:
    Servidor_stub_clp (PortableServer::POA_ptr, CORBA::Object_ptr);
    virtual ~Servidor_stub_clp ();
    CORBA::Long processaJogo( CORBA::Long digitadoPlayer1, CORBA::Long digitadoPlayer2 );
    ::TLogica getTLogica();

  protected:
    Servidor_stub_clp ();
  private:
    void operator=( const Servidor_stub_clp & );
};

#endif // MICO_CONF_NO_POA

#ifndef MICO_CONF_NO_POA

class POA_Servidor : virtual public PortableServer::StaticImplementation
{
  public:
    virtual ~POA_Servidor ();
    Servidor_ptr _this ();
    bool dispatch (CORBA::StaticServerRequest_ptr);
    virtual void invoke (CORBA::StaticServerRequest_ptr);
    virtual CORBA::Boolean _is_a (const char *);
    virtual CORBA::InterfaceDef_ptr _get_interface ();
    virtual CORBA::RepositoryId _primary_interface (const PortableServer::ObjectId &, PortableServer::POA_ptr);

    virtual void * _narrow_helper (const char *);
    static POA_Servidor * _narrow (PortableServer::Servant);
    virtual CORBA::Object_ptr _make_stub (PortableServer::POA_ptr, CORBA::Object_ptr);

    virtual CORBA::Long processaJogo( CORBA::Long digitadoPlayer1, CORBA::Long digitadoPlayer2 ) = 0;
    virtual ::TLogica getTLogica() = 0;

  protected:
    POA_Servidor () {};

  private:
    POA_Servidor (const POA_Servidor &);
    void operator= (const POA_Servidor &);
};

#endif // MICO_CONF_NO_POA

extern CORBA::StaticTypeInfo *_marshaller_est;

extern CORBA::StaticTypeInfo *_marshaller_obj;

extern CORBA::StaticTypeInfo *_marshaller_log;

extern CORBA::StaticTypeInfo *_marshaller_Servidor;

extern CORBA::StaticTypeInfo *_marshaller__a20_obj;

extern CORBA::StaticTypeInfo *_marshaller__a30_obj;

#endif
